<?php
/*
    This filter makes sure there is always a Contact instance in the event.
*/

class ContactManager_filters_ContactBeanerFilter extends MachII_framework_EventFilter
{
    function filterEvent(&$event, &$eventContext, $paramArgs = array())
    {
        if ($event->isArgDefined('contact')) {
            // Do nothing, it already exists.
        } elseif (isset($GLOBALS['contact'])) {
            // Put it in the event.
            $event->setArg('contact', $GLOBALS['contact']);
        } else {
            // Create it based on the parameters in the request.
            $className = MachII_util_ClassLoader::load('ContactManager.model.Contact');
            $contact =& new $className();
            
            $contact->setFirstName($event->getArg('firstName', ''));
            $contact->setLastName($event->getArg('lastName', ''));
            $contact->setStreet($event->getArg('street', ''));
            $contact->setCity($event->getArg('city', ''));
            $contact->setState($event->getArg('state', ''));
            $contact->setZip($event->getArg('zip', ''));
            
            $event->setArg('contact', $contact);
        }
        
        return true;
    }
}

?>