<?php

require_once 'Contact.php';

class ContactManager_model_ContactManager extends MachII_framework_Listener
{
    var $_contacts = array();
    
    function createContact(&$event)
    {
        $args =& $event->getArgs();
        
        $contact =& new ContactManager_model_Contact();
        $contact->setInfo($args);
        
        $this->_contacts[$contact->getId()] =& $contact;
        
        $newEventArgs['contact'] =& $contact;
        $this->announceEvent('contactCreated', $newEventArgs);
    }
    
    function updateContact(&$event)
    {
        $args =& $event->getArgs();
        
        if (isset($this->_contacts[$args['id']])) {
            $contact =& $this->getContact($event);
            $contact->setInfo($args);
            
            $newEventArgs['contact'] =& $contact;
            $this->announceEvent('contactUpdated', $newEventArgs);
        } else {
            //Contact Doesn't exist.
            //This could be handled by announcing another event instead of an exception.
            $error =& MachII::throwError(
                "Contact with ID $args[id] does not exist.",
                MACHII_ERROR_CUSTOM
            );
            return $error;
        }
    }
    
    function &getContact(&$event)
    {
        $id = $event->getArg('id');
        
        if (isset($this->_contacts[$id])) {
            return $this->_contacts[$id];
        } else {
            $error =& MachII::throwError(
                "Contact with ID $id does not exist.",
                MACHII_ERROR_CUSTOM
            );
            return $error;
        }
    }
    
    function &getAllContacts()
    {
        return $this->_contacts;
    }
}

?>