<?php
/*
   +----------------------------------------------------------------------+
   | PEAR Web site version 1.0                                            |
   +----------------------------------------------------------------------+
   | Copyright (c) 2001-2003 The PHP Group                                |
   +----------------------------------------------------------------------+
   | This source file is subject to version 2.02 of the PHP license,      |
   | that is bundled with this package in the file LICENSE, and is        |
   | available at through the world-wide-web at                           |
   | http://www.php.net/license/2_02.txt.                                 |
   | If you did not receive a copy of the PHP license and are unable to   |
   | obtain it through the world-wide-web, please send a note to          |
   | license@php.net so we can mail you a copy immediately.               |
   +----------------------------------------------------------------------+
   | Authors: Martin Jansen <mj@php.net>                                  |
   +----------------------------------------------------------------------+
   $Id: index.php,v 1.90 2003/12/22 12:42:30 mj Exp $
*/

response_header();
?>

<h1>Mach-II for PHP</h1>

<?php

if (isset($_COOKIE['PEAR_USER'])) {
    /*
    echo '<h2>Package Proposals (PEPr Live Test)</h2>';
    echo '<div class="indent">';
    echo menu_link("Browse Proposals", "pepr/pepr-overview.php");
    echo menu_link("New Package Proposal", "pepr/pepr-proposal-edit.php");
    echo '</div>';
    */
    echo '<h2>Developers</h2>';
    echo '<div class="indent">';

    echo menu_link("Upload Release", "release-upload.php");
    echo menu_link("New Package", "package-new.php");

    if (user::isAdmin($_COOKIE['PEAR_USER'])) {
        echo '<h2>Administrators</h2>';
        echo '<div class="indent">';
        echo menu_link("Overview", "/admin/");
        echo '</div>';
    }

    echo '</div>';
} else {
?>

<p>
Mach-II is a powerful framework for building modular and <emphasis>maintainable</emphasis> object-oriented applications.
</p>

<p>
Mach-II is based on a well accepted software <a href="http://www.dossier-andreas.net/software_architecture/">architecture</a> known as event-based, implicit invocation.  It is a very flexible method of linking modular application components together and is used by most operating systems and virtually all GUI interfaces - it works!  
</p>

<p>
See the <a href="http://www.mach-ii.com/faq.cfm">FAQ</a> and the <a href="/manual">manual</a> for more information.
</p>

<?php
/*echo hdelim();


<p>If you have been told by other Mach-II developers to sign up for a
Mach-II for PHP website account, you can use <a href="account-request.php">
this interface</a>.</p>
*/?>
<?php
}

$recent = release::getRecent();
if (@sizeof($recent) > 0) {
    $RSIDEBAR_DATA = "<h3>Recent Releases</h3>\n";
    $RSIDEBAR_DATA .= "<table>";
    foreach ($recent as $release) {
        extract($release);
        $releasedate = substr($releasedate, 0, 10);
        $desc = substr($releasenotes, 0, 40);
        if (strlen($releasenotes) > 40) {
            $desc .= '...';
        }
        $desc = htmlentities($desc);
        $RSIDEBAR_DATA .= "<tr><td valign='top' class='compact'>";
        $RSIDEBAR_DATA .= "<a href=\"/package/" . $name . "/\">";
        $RSIDEBAR_DATA .= "$name $version</a><br /><i>$releasedate:</i> $desc</td></tr>";
    }
    //$feed_link = make_link("/feeds/", "Syndicate this");
    //$RSIDEBAR_DATA .= "<tr><td>&nbsp;</td></tr>\n";
    //$RSIDEBAR_DATA .= "<tr><td width=\"100%\" align=\"right\">" . $feed_link . "</td></tr>\n";
    $RSIDEBAR_DATA .= "</table>\n";
}

response_footer();

?>

