<?php
/**
 * @package MachII
 */
/**
 * EventCommand class.
 * 
 * The base EventCommand class.
 * @package MachII
 */
class MachII_framework_EventCommand
{
    /**
     * Parameters
     * 
     * EventCommand parameters are set via the configuration file.
     * @access protected
     * @var array associative array
     */
    var $_parameters = array();
    
    
    /**
     * @param MachII_framework_Event
     * @param MachII_framework_EventContext
     * @return MACHII_OK
     */
    function execute(&$event, &$eventContext)
    {
        return MACHII_OK;
    }
    
    /**
     * @param string
     * @param mixed
     */
    function setParameter($name, &$value)
    {
        $this->_parameters[$name] =& $value;
    }
    
    /**
     * @param string
     * @return string
     */
    function &getParameter($name)
    {
        return $this->_parameters[$name];
    }
    
    /**
     * @access protected
     * @param array associative array will be merged with any existing parameters
     */
    function _setParameters($parameters)
    {
        $this->_parameters = array_merge($this->_parameters, $parameters);
    }

}

?>