<?php
/**
 * @package MachII
 */
/**
 * Manages registered views.
 * @package MachII
 */
class MachII_framework_ViewManager
{
    /**
     * @var MachII_framework_AppManager
     * @access private
     */
    var $_appManager;
    
    /**
     * @var array associative array of filesystem paths
     * @access private
     */
    var $_viewPaths = array();
    
    
    /**
     * @param array associative array of filesystem paths
     * @param MachII_framework_AppManager
     */
    function init($pageViews, &$appManager)
    {
        $this->setAppManager($appManager);
        $this->_viewPaths = $pageViews;
    }
    
    /**
     * @internal not used at this time 
     */
    function configure() {}
    
    /**
     * @param string
     * @throws MACHII_VIEW_NOT_DEFINED
     * @return string
     */
    function getViewPath($viewName)
    {
    //$GLOBALS['vard']->display($this->_viewPaths);
        if (!$this->isViewPathDefined($viewName)) {
            $error =& MachII::throwError(
                array('viewName' => $viewName),
                MACHII_ERROR_VIEW_NOT_DEFINED
            );
            return $error;
        }
        //echo 'viewManager->getViewPath: ',$this->_viewPaths[$viewName],'<br />';
        return $this->_viewPaths[$viewName];
    }
    
    /**
     * @param string
     * @return boolean
     */
    function isViewPathDefined($viewName)
    {
        return isset($this->_viewPaths[$viewName]);
    }
    
    /**
     * @param MachII_framework_AppManager
     */
    function setAppManager(&$appManager)
    {
        $this->_appManager =& $appManager;
    }
    
    /**
     * @return MachII_framework_AppManager
     */
    function &getAppManager()
    {
        return $this->_appManager;
    }

}

?>