<?php
/**
 * @package MachII
 */
/**
 * Handles view display for a  {@link MachII_framework_EventContext}.
 * @package MachII
 */
class MachII_framework_ViewContext
{
    /**
     * @var MachII_framework_AppManager
     * @access private
     */
    var $_appManager;
    
    
    /**
     * @param MachII_framework_AppManager
     */
    function MachII_framework_ViewContext(&$appManager)
    {
        $this->setAppManager($appManager);
    }
    
    /**
     * @param MachII_framework_Event or descendent
     * @param string
     * @param string|void string representation of a variable name
     */
    function displayView(&$event, $viewName, $contentKey = null)
    {//echo 'ViewContext->displayView - $viewName: ',$viewName,'<br />';
        $GLOBALS['event'] =& $event;
        $viewPath = $this->_getFullPath($viewName);
        if (MachII::isError($viewPath)) {
            return $viewPath;
        }
        //echo $viewPath,'<br />';
        if (!empty($contentKey)) {
            ob_start();
            include $viewPath;
            $content = ob_get_clean();            
            
            if ($content === false) {
                $content = '';
            }
            
            // Create content container and reference it
            if (strstr($contentKey, '[')) {
                eval("return \$$contentKey =& \$content;");
            } else {
                $event->setArg($contentKey, $content);
            }
        } else {
            include $viewPath;
        }
    }
    
    /**
     * @param MachII_framework_AppManager
     */
    function setAppManager(&$appManager)
    {
        $this->_appManager =& $appManager;
    }
    
    /**
     * @return MachII_framework_AppManager
     */
    function &getAppManager()
    {
        return $this->_appManager;
    }
    
    /**
     * @param string
     * @return string
     * @access private
     */
    function _getFullPath($viewName)
    {
        $appManager  =& $this->getAppManager();
        $viewManager =& $appManager->getViewManager();
        $viewPath    =& $viewManager->getViewPath($viewName);
        if (MachII::isError($viewPath)) {
            return $viewPath;
        }
        
        $appRoot = $this->_getAppRoot();
        
        if ($appRoot{0} == '/') {
            $webRoot = MachII_util_ClassLoader::getWebRoot();
            if (file_exists($webRoot.$appRoot.$viewPath)) {
                return $webRoot.$appRoot.$viewPath;
            }
        }
        
        return $appRoot.$viewPath;
    }
    
    /**
     * @return string the defined application root
     * @access private
     */
    function _getAppRoot()
    {
        $appManager      =& $this->getAppManager();
        $propertyManager =& $appManager->getPropertyManager();
        
        return $propertyManager->getProperty('applicationRoot');
    }

}

?>