<?php
/**
 * @package MachII
 * @subpackage Commands
 */
/**
 * An EventCommand for setting up an event mapping for an event handler.
 * @package MachII
 * @subpackage Commands
 */
class MachII_framework_commands_EventMappingCommand extends MachII_framework_EventCommand
{
    /**
     * @access private
     * @var string
     */
    var $_eventName;
    /**
     * @access private
     * @var string
     */
    var $_mappingName;
    
    
    /**
     * @param string
     * @param string
     */
    function MachII_framework_commands_EventMappingCommand($eventName, $mappingName)
    {
        $this->_setEventName($eventName);
        $this->_setMappingName($mappingName);
    }
    
    /**
     * @param MachII_framework_Event MachII_framework_Event descendent
     * @param MachII_framework_EventContext
     * @return MACHII_OK
     */
    function execute(&$event, &$eventContext)
    {
        $eventContext->setEventMapping($this->_getEventName(), $this->_getMappingName());
        
        return MACHII_OK;
    }
    
    /**
     * @param string
     */
    function _setEventName($eventName)
    {
        $this->_eventName = $eventName;
    }
    
    /**
     * @return string
     */
    function _getEventName()
    {
        return $this->_eventName;
    }
    
    /**
     * @param string
     */
    function _setMappingName($mappingName)
    {
        $this->_mappingName = $mappingName;
    }
    
    /**
     * @return string
     */
    function _getMappingName()
    {
        return $this->_mappingName;
    }

}
?>