<?php
/**
 * @package Util
 * @subackage MachII_util_Exception
 */
/**
 * An abstraction layer from the error system.
 * @package Util
 * @subackage MachII_util_Exception
 */
class MachII_util_Exception
{
    /**
     * @access private
     * @var string
     */
    var $_type;
    /**
     * @access private
     * @var string
     */
    var $_message;
    /**
     * @access private
     * @var integer
     */
    var $_errorCode;
    /**
     * @access private
     * @var string
     */
    var $_detail;
    /**
     * @access private
     * @var string
     */
    var $_extendedInfo;
    /**
     * @access private
     * @var array
     */
    var $_context = array();
    
    
    /**
     * @param PEAR_Error
     */
    function MachII_util_Exception($error)
    {
        $this->setType($error->getType());
        $this->setMessage(MachII::errorMessage($error->getCode(), $error->message));
        $this->setErrorCode($error->getCode());
        $this->setDetail($error->getUserInfo());
        //$this->setExtendedInfo($error->toString());
        if (is_array($error->getBacktrace())) {
            $this->setContext($error->getBacktrace());
        }
    }
    
    /**
     * @param string
     */
    function setType($type)
    {
        $this->_type = $type;
    }
    
    /**
     * @return string
     */
    function getType()
    {
        return $this->_type;
    }
    
    /**
     * @param string
     */
    function setMessage($message)
    {
        $this->_message = $message;
    }
    
    /**
     * @return string
     */
    function getMessage()
    {
        return $this->_message;
    }
    
    /**
     * @param integer
     */
    function setErrorCode($errorCode)
    {
        $this->_errorCode = $errorCode;
    }
    
    /**
     * @return integer
     */
    function getErrorCode()
    {
        return $this->_errorCode;
    }
    
    /**
     * @param string
     */
    function setDetail($detail)
    {
        $this->_detail = $detail;
    }
    
    /**
     * @return string
     */
    function getDetail()
    {
        return $this->_detail;
    }
    
    /**
     * @param string
     */
    function setExtendedInfo($extendedInfo)
    {
        $this->_extendedInfo = $extendedInfo;
    }
    
    /**
     * @return string
     */
    function getExtendedInfo()
    {
        return $this->_extendedInfo;
    }
    
    /**
     * @param string
     */
    function setContext($context)
    {
        $this->_context = $context;
    }
    
    /**
     * @return
     */
    function getContext()
    {
        return $this->_context;
    }

}
?>