<?php
/**
 * @package MachII
 */
/**
 * EventCommand class.
 * 
 * The base EventCommand class.
 * @package MachII
 */
abstract class MachII_framework_EventCommand
{
    /**
     * Parameters
     * 
     * EventCommand parameters are set via the configuration file.
     * @access protected
     * @var array associative array
     */
    protected $_parameters = array();
    
    
    /**
     * @abstract
     * @param MachII_framework_Event
     * @param MachII_framework_EventContext
     * @return MACHII_OK
     */
    public abstract function execute(MachII_framework_Event $event, MachII_framework_EventContext $eventContext);
    
    /**
     * @param string
     * @param mixed
     */
    public function setParameter($name, $value)
    {
        $this->_parameters[$name] = $value;
    }
    
    /**
     * @param string
     * @return string
     */
    public function getParameter($name)
    {
        return $this->_parameters[$name];
    }
    
    /**
     * @access protected
     * @param array associative array will be merged with any existing parameters
     */
    protected function setParameters($parameters)
    {
        $this->_parameters = array_merge($this->_parameters, $parameters);
    }

}

?>