<?php
/**
 * @package Util
 * @subackage MachII_util_Exception
 */
/**
 * An abstraction layer from the error system.
 * @package Util
 * @subackage MachII_util_Exception
 */
class MachII_util_Exception
{
    /**
     * @access private
     * @var string
     */
    private $_type;
    /**
     * @access private
     * @var string
     */
    private $_message;
    /**
     * @access private
     * @var integer
     */
    private $_errorCode;
    /**
     * @access private
     * @var string
     */
    private $_detail;
    /**
     * @access private
     * @var string
     */
    private $_extendedInfo;
    /**
     * @access private
     * @var array
     */
    private $_context = array();
    
    
    /**
     * @param PEAR_Error
     */
    public function __construct($error)
    {
        $this->setType($error->getType());
        $this->setMessage(MachII::errorMessage($error->getCode(), $error->message));
        $this->setErrorCode($error->getCode());
        $this->setDetail($error->getUserInfo());
        //$this->setExtendedInfo($error->toString());
        if (is_array($error->getBacktrace())) {
            $this->setContext($error->getBacktrace());
        }
    }
    
    /**
     * @param string
     */
    public function setType($type)
    {
        $this->_type = $type;
    }
    
    /**
     * @return string
     */
    public function getType()
    {
        return $this->_type;
    }
    
    /**
     * @param string
     */
    public function setMessage($message)
    {
        $this->_message = $message;
    }
    
    /**
     * @return string
     */
    public function getMessage()
    {
        return $this->_message;
    }
    
    /**
     * @param integer
     */
    public function setErrorCode($errorCode)
    {
        $this->_errorCode = $errorCode;
    }
    
    /**
     * @return integer
     */
    public function getErrorCode()
    {
        return $this->_errorCode;
    }
    
    /**
     * @param string
     */
    public function setDetail($detail)
    {
        $this->_detail = $detail;
    }
    
    /**
     * @return string
     */
    public function getDetail()
    {
        return $this->_detail;
    }
    
    /**
     * @param string
     */
    public function setExtendedInfo($extendedInfo)
    {
        $this->_extendedInfo = $extendedInfo;
    }
    
    /**
     * @return string
     */
    public function getExtendedInfo()
    {
        return $this->_extendedInfo;
    }
    
    /**
     * @param array
     */
    public function setContext($context)
    {
        $this->_context = $context;
    }
    
    /**
     * @return array
     */
    public function getContext()
    {
        return $this->_context;
    }

}
?>