<?php
/**
 * @package MachII
 */
/**
 * Handles view display for a  {@link MachII_framework_EventContext}.
 * @package MachII
 */
class MachII_framework_ViewContext
{
    /**
     * @var MachII_framework_AppManager
     * @access private
     */
    private $_appManager;
    
    
    /**
     * @param MachII_framework_AppManager
     */
    public function __construct(MachII_framework_AppManager $appManager)
    {
        $this->setAppManager($appManager);
    }
    
    /**
     * @param MachII_framework_Event or descendent
     * @param string
     * @param string|void string representation of a variable name
     */
    public function displayView(MachII_framework_Event $event, $viewName, $contentKey = null)
    {//echo 'ViewContext->displayView - $viewName: ',$viewName,'<br />';
        $GLOBALS['event'] = $event;
        $viewPath = $this->_getFullPath($viewName);
        //echo $viewPath,'<br />';
        if (!empty($contentKey)) {
            ob_start();
            include $viewPath;
            $content = ob_get_clean();            
            
            if ($content === false) {
                $content = '';
            }
            
            // Create content container and reference it
            if (strstr($contentKey, '[')) {
                eval("return \$$contentKey =& \$content;");
            } else {
                $event->setArg($contentKey, $content);
            }
        } else {
            include $viewPath;
        }
    }
    
    /**
     * @param MachII_framework_AppManager
     */
    public function setAppManager(MachII_framework_AppManager $appManager)
    {
        $this->_appManager = $appManager;
    }
    
    /**
     * @return MachII_framework_AppManager
     */
    public function getAppManager()
    {
        return $this->_appManager;
    }
    
    /**
     * @param string
     * @return string
     * @access private
     */
    private function _getFullPath($viewName)
    {
        $viewPath = $this->getAppManager()->getViewManager()->getViewPath($viewName);
        
        $appRoot = $this->_getAppRoot();
        
        if ($appRoot{0} == '/') {
            $webRoot = MachII_util_ClassLoader::getWebRoot();
            if (file_exists($webRoot.$appRoot.$viewPath)) {
                return $webRoot.$appRoot.$viewPath;
            }
        }
        
        return $appRoot.$viewPath;
    }
    
    /**
     * @return string the defined application root
     * @access private
     */
    private function _getAppRoot()
    {
        return $this->getAppManager()->getPropertyManager()->getProperty('applicationRoot');
    }

}

?>