<?php
/**
 * @package Util
 * @subpackage MachII_util_Queue
 */
/**
 * @package Util
 * @subpackage MachII_util_Queue
 */
class MachII_util_Queue
{
    /**
     * Initializes the queue.
     * @access private
     * @var array
     */
    private $_queueArray = array();
    
    
    /**
     * Queues the item.
     * @param mixed
     */
    public function put($item)
    {
        $this->_queueArray[] = $item;
        //array_push($this->queueArray, $item);
    }
    
    /**
     * Dequeues and returns the next item in the queue.
     * @return mixed
     */
    public function get()
    {
        return array_shift($this->_queueArray);
    }
    
    /**
     * Peeks the next item in the queue without removing it.
     * @return mixed
     */
    public function peek()
    {
        return $this->_queueArray[0];
    }
    
    /**
     * Clears the queue.
     */
    public function clear()
    {
        $this->_queueArray = array();
    }
    
    /**
     * Returns the size of the queue (number of elements).
     * @return integer
     */
    public function getSize()
    {
        return count($this->_queueArray);
    }
    
    /**
     * Returns whether or not the queue is empty.
     * @return boolean
     */
    public function isEmpty()
    {
        return empty($this->_queueArray);
    }

}

?>