<?php
/**
 * @package MachII
 * @subpackage Commands
 */
/**
 * An EventCommand for setting up an event mapping for an event handler.
 * @package MachII
 * @subpackage Commands
 * @author Ben Edwards <ben@ben-edwards.com>
 * @author Alan Richmond <alan@aardwolfweb.com>
 */
class MachII_framework_commands_EventMappingCommand extends MachII_framework_EventCommand
{
    /**
     * @access private
     * @var string
     */
    private $_eventName;
    /**
     * @access private
     * @var string
     */
    private $_mappingName;
    
    
    /**
     * @param string
     * @param string
     */
    public function __construct($eventName, $mappingName)
    {
        $this->_setEventName($eventName);
        $this->_setMappingName($mappingName);
    }
    
    /**
     * @param MachII_framework_Event MachII_framework_Event descendent
     * @param MachII_framework_EventContext
     * @return true
     */
    public function execute(MachII_framework_Event $event, MachII_framework_EventContext $eventContext)
    {
        $eventContext->setEventMapping($this->_getEventName(), $this->_getMappingName());
        
        return true;
    }
    
    /**
     * @access private
     * @param string
     */
    private function _setEventName($eventName)
    {
        $this->_eventName = $eventName;
    }
    
    /**
     * @access private
     * @return string
     */
    private function _getEventName()
    {
        return $this->_eventName;
    }
    
    /**
     * @access private
     * @param string
     */
    private function _setMappingName($mappingName)
    {
        $this->_mappingName = $mappingName;
    }
    
    /**
     * @access private
     * @return string
     */
    private function _getMappingName()
    {
        return $this->_mappingName;
    }

}
?>