<?php
/**
 * @package MachII
 */
/**
 * EventFilter class.
 * @package MachII
 * @author Ben Edwards <ben@ben-edwards.com>
 * @author Alan Richmond <alan@aardwolfweb.com>
 */
abstract class MachII_framework_EventFilter extends MachII_framework_BaseObject
{
    /**
     * @var MachII_framework_AppManager
     * @access private
     */
    private $_appManager;
    /**
     * @var array associative array of filter parameters
     * @access private
     */
    private $_parameters = array();
    
    
    /**
     * @param MachII_framework_AppManager
     * @param array associative array of event filter parameters
     */
    public function __construct(MachII_framework_AppManager $appManager, $parameters)
    {
        parent::__construct($appManager, $parameters);
    }
    
    /**
     * Override to provide event filtering logic.
     * @param MachII_framework_Event or descendent
     * @param MachII_framework_EventContext
     * @param array associative array of filter parameters
     * @abstract
     * @return boolean
     */
    public abstract function filterEvent(MachII_framework_Event $event, MachII_framework_EventContext $eventContext, $paramArgs = array());

}
?>