<?php
/**
 * @package Filter
 * @subpackage MachII_filter_ValidateObject
 */
/**
 * Calls a "validate" method on an object.
 * Written for PEAR HTML_QuickForm (http://pear.php.net/package/HTML_QuickForm)
 * objects but will work with any form bean with a "validate" method.
 * @package Filter
 * @subpackage MachII_filter_ValidateObject
 */

class MachII_filters_ValidateObject extends MachII_framework_EventFilter
{
    /**
     * @param MachII_framework_Event
     * @param MachII_framework_EventContext
     * @param array associative array of filter parameters
     * @return boolean
     */
    function filterEvent(&$event, &$eventContext, &$paramArgs)
    {
        $objectName = (isset($paramArgs['objectName']))?
            $paramArgs['objectName']:
            $this->getParameter('objectName', '');
        
        $failEvent = (isset($paramArgs['failEvent']))?
            $paramArgs['failEvent']:
            $this->getParameter('failEvent', '');
        
        $clearEventQueue = (isset($paramArgs['clearEventQueue']))?
            $paramArgs['clearEventQueue']:
            $this->getParameter('clearEventQueue', false);
        
        $object =& $event->getArg($objectName);
        
        if ($object->validate()) {
            return true;
        } else {
            if ($clearEventQueue) {
                $eventContext->clearEventQueue();
            }
            $eventContext->announceEvent($failEvent, $event->getArgs());
            
            return false;
        }
    }
}
?>