<?php

class Roulette_model_RouletteTable extends MachII_framework_Listener
{
    var $_player;
    var $_bet;
    var $_history;
    
    function Roulette_model_RouletteTable()
    {
        $betClass     = MachII_util_ClassLoader::load('Roulette.model.Bet');
        $historyClass = MachII_util_ClassLoader::load('Roulette.model.History');
        
        $this->_bet     =& new $betClass();
        $this->_history =& new $historyClass();
    }
    
    function newPlayer(&$event)
    {
        
        $playerClass = MachII_util_ClassLoader::load('Roulette.model.Person');
        
        $this->_player =& new $playerClass($event->getArg('playerName'), $event->getArg('stake'));
        $this->_bet->clearBet();
    }
    
    function &getPlayer()
    {
        return $this->_player;
    }
    
    function &getBet()
    {
        return $this->_bet;
    }
    
    function &getHistory()
    {
        return $this->_history;
    }
    
    function getGameState()
    {
        $bet     =& $this->getBet();
        $history =& $this->getHistory();
        $player  =& $this->getPlayer();
        $account =& $player->getBankAccount();
        
        $state = array(
            'betAmount'  => $bet->getAmountBet(),
            'history'    => $history->getWinners(),
            'stake'      => $account->getBankAmount(),
            'playerName' => $player->getName()
        );
        
        return $state;
    }
    
    function placeBet(&$event)
    {
        $amountBet  = $event->getArg('amountBet');
        $numbersBet = $event->getArg('numbersBet');
        
        $player  =& $this->getPlayer();
        $account =& $player->getBankAccount();
        $bet     =& $this->getBet();
        
        if ((count($numbersBet) * $amountBet) <= $account) {
            $bet->setAmountBet($amountBet);
            $bet->setNumbersBet($numbersBet);
            $this->announceEvent('acceptedBet');
        } else {
            $this->rejectBet();
        }
    }
    
    function settleGame()
    {
        $bet =& $this->getBet();
        $history =& $this->getHistory();
        
        $winner = $this->generateWinningNumber();
        $numbersBet = $bet->getNumbersBet();
        
        $history->addToHistory($winner);
        
        if (in_array($winner, $numbersBet)) {
            $this->playerWins();
        } else {
            $this->playerLoses();
        }
    }
    
    function playerWins()
    {
        $player  =& $this->getPlayer();
        $account =& $player->getBankAccount();
        $bet     =& $this->getBet();
        
        $account->creditAccount($bet->getAmountBet() * 37);
    }
    
    function playerLoses()
    {
        $player  =& $this->getPlayer();
        $account =& $player->getBankAccount();
        $bet     =& $this->getBet();
        
        $numberOfBets = count($bet->getNumbersBet());
        
        $account->debitAccount($bet->getAmountBet() * $numberOfBets);
    }
    
    function rejectBet()
    {
        $this->announceEvent('rejectedBet', array('message' => 'You don\'t have enough to place that bet.'));
    }
    
    function generateWinningNumber()
    {
        //seed for PHP <4.2.0
        list($usec, $sec) = explode(' ', microtime());
        $seed = (float) $sec + ((float) $usec * 100000);
        mt_srand($seed);
        $winner = mt_rand(1, 38);
        
        if ($winner == 37) {
            return '0';
        } elseif ($winner == 38) {
            return '00';
        }
        
        return $winner;
    }
}

?>