<?php

require_once 'DataManager.php';
require_once 'ProductFactory.php';
require_once 'Cart.php';

class ShoppingCart_model_ShoppingCart extends MachII_framework_Listener
{
    var $_dataManager;
    var $_productFactory;
    
    function configure()
    {
        $this->_dataManager =& new ShoppingCart_model_DataManager($this->getAppManager());
        $this->_productFactory =& new ShoppingCart_model_ProductFactory();
    }
    
    function addItem(&$event)
    {
        $productID = $event->getArg('productID');
        if (!isset($_SESSION['cart'])) {
            $_SESSION['cart'] =& new ShoppingCart_model_Cart();
        }
        
        $productInfo = $this->_dataManager->getProductInfo($productID);
        
        $product =& $this->_productFactory->createProduct($productInfo['productID'], $productInfo['name'], $productInfo['description'], $productInfo['price'], $productInfo['type']);
        
        $_SESSION['cart']->addItem($product);
    }
    
    function removeItem(&$event)
    {
        $productID = $event->getArg('productID');
        if (isset($_SESSION['cart'])) {
            $_SESSION['cart']->subtractItem($productID);
        }
    }
    
    function getCart()
    {
        return $_SESSION['cart'];
    }
    
    function getItems()
    {
        return $_SESSION['cart']->getItems();
    }
}

?>