<?php

require_once 'CartItem.php';

class ShoppingCart_model_Cart
{
    private $_items = array();
    
    public function addItem($product)
    {
        $productID = $product->getProductID();
        
        if (isset($this->_items[$productID])) {
            $this->_items[$productID]->incrementQuantity();
        } else {
            $this->_items[$productID] = new ShoppingCart_model_CartItem($product);
        }
    }
    
    public function subtractItem($productId)
    {
        if (isset($this->_items[$productId])) {
            if ($this->_items[$productId] > 1) {
                $this->_items[$productId]->decrementQuantity();
            } else {
                unset($this->_items[$productId]);
            }
        }
    }
    
    public function getItems()
    {
        return $this->_items;
    }
}

?>